<?php

/**
 * @package		joomlaCHMOD.php
 * @copyright	Copyright (C) 2005 - 2013 ColorPack Creations CO.,LTD., Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

/******************************************************************************/

define('HOSTNAME',	'localhost');
define('HTMLDIR',	dirname(__FILE__) );
define('SCRIPTNAME',	basename(__FILE__));

/******************************************************************************
CMS directory list
******************************************************************************/

//Joomla 2.5
$cmsdir['joomla25'] = array(
	'administrator/cache',
	'administrator/components',
	'administrator/language',
	'administrator/language/en-GB',
	'administrator/language/overrides',
	'administrator/manifests/files',
	'administrator/manifests/libraries',
	'administrator/manifests/packages',
	'administrator/modules',
	'administrator/templates',
	'cache',
	'components',
	'images',
	'images/banners',
	'language',
	'language/en-GB',
	'language/overrides',
	'libraries',
	'media',
	'modules',
	'plugins',
	'plugins/authentication',
	'plugins/captcha',
	'plugins/content',
	'plugins/editors',
	'plugins/editors-xtd',
	'plugins/extension',
	'plugins/finder',
	'plugins/quickicon',
	'plugins/search',
	'plugins/system',
	'plugins/user',
	'plugins/xmap',
	'templates',
	'log',
	'tmp'
	);
//Joomla 3.x
$cmsdir['joomla30'] = array(
	'administrator/cache',
	'administrator/components',
	'administrator/language',
	'administrator/language/en-GB',
	'administrator/language/overrides',
	'administrator/manifests/files',
	'administrator/manifests/libraries',
	'administrator/manifests/packages',
	'administrator/modules',
	'administrator/templates',
	'cache',
	'components',
	'images',
	'images/banners',
	'images/headers',
	'images/sampledata',
	'language',
	'language/en-GB',
	'language/overrides',
	'libraries',
	'media',
	'modules',
	'plugins',
	'plugins/authentication',
	'plugins/captcha',
	'plugins/content',
	'plugins/editors',
	'plugins/editors-xtd',
	'plugins/extension',
	'plugins/finder',
	'plugins/quickicon',
	'plugins/search',
	'plugins/system',
	'plugins/twofactorauth',
	'plugins/user',
	'templates',
	'log',
	'tmp'
	);


/******************************************************************************
Function
******************************************************************************/
	
function showParams($varname, $params) {
	echo '<h3>'.$varname.'</h3><p>';
	var_dump($params);
	echo '</p>';
}

function ftpconnect($ftphost, $ftpport, $ftpuser, $ftppass) {
	if($ftphost) {$ftphost = HOSTNAME;}
	if($ftpport == '') {$ftpport = '21';}
	$ftpconnect	= ftp_connect($ftphost, $ftpport);
	$ftplogin	= ftp_login($ftpconnect, $ftpuser, $ftppass);
	return $ftpconnect;
}

function recursive_chmod($dir, $dir_perm = '0775', $file_perm = '0664') {
	global $ftpconnect;
	
	if(is_dir($dir)){
		if ($dh = opendir($dir)) {
			while (($file = readdir($dh)) !== false) {
				if ( $file == "." || $file == ".." ) continue;
				if ( filetype($dir.'/'.$file) == "dir" ){
					recursive_chmod($dir.'/'.$file, $dir_perm, $file_perm);
					ftp_site($ftpconnect,'CHMOD '.$dir_perm.' '.$dir.'/'.$file);
					#$html .= $dir.'/'.$file.'[Directory] Permission: '.$dir_perm.'<br />';
				}
				else {
					ftp_site($ftpconnect,'CHMOD '.$file_perm.' '.$dir.'/'.$file);
					#$html .= $dir.'/'.$file.'[File] Permission: '.$file_perm.'<br />';
				}
			}
			ftp_site($ftpconnect,'CHMOD '.$dir_perm.' '.$dir);
			closedir($dh);
		}
	}
}
/******************************************************************************
Start CMS chmod mission
******************************************************************************/

// parameter
$cmstype = $_POST['cmstype'];
$ftphost = $_POST['ftphost'];
$ftpport = $_POST['ftpport'];
$ftpuser = $_POST['ftpuser'];
$ftppass = $_POST['ftppass'];
$ftppath = $_POST['ftppath'];

$script  = SCRIPTNAME;

// text
$textCMS  = 'Select CMS Type';
$textHost = 'FTP Hostname';
$textPort = 'FTP Port';
$textUser = 'FTP Username';
$textPass = 'FTP Password';
$textPath = 'FTP Path';
$authText = 'Submit';

$htmldir = HTMLDIR;
$targetdir = $htmldir; //default path

if ($ftppath) {$targetdir = $ftppath;}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="keywords" content="cms, chmod, php, joomla" />
<meta name="description" content="Joomla! CHMOD php script" />
<title>Joomla  CHMOD php script</title>
<style type="text/css">
<!--
html *, .no-margin {margin:0; padding:0;}
body {background: #f0f0f0; font-family: Verdana, Tahoma, Arial, Helvetica, sans-serif; font-size: 12px; color: #333;}
h1, h2, h3, h4, h5 {font-family: Arial, Tahoma, Helvetica, sans-serif; color: #003366;}
h1, h2, h3, h4, h5, p {margin: 15px 0;}
table {border: 0;}
form td {padding :3px; }
.container {position: relative;}
.main {position: relative; margin: 50px auto 0; width: 960px; padding: 20px; background: #f5f5f5; border: 1px solid #ccc; border-radius: 10px; -moz-border-radius: 10px; -webkit-border-radius: 10px; }
.main.form {width: 400px;}
.selectbox {padding:3px 5px; width: 120px; background: #fff; border:0; border-radius: 3px; -moz-border-radius: 3px; -webkit-border-radius: 3px;}
.inputbox {padding:3px 5px; width: 250px; background: #fff; border:0; border-radius: 3px; -moz-border-radius: 3px; -webkit-border-radius: 3px;}
.submit-button {margin: 10px 0 0;}
.footer {color: #666; margin: 20px auto; text-align: center; }

-->
</style>
</head>
</head>

<body>
<?php
if ( $_GET['task'] == 'chmod' ) {

	// connect ftp
	$ftpconnect = ftpconnect($ftphost, $ftpport, $ftpuser, $ftppass);
	
	?>
	<div class='main'>
	<h2>CMS chmod script</h2>

	<?php
	#global permission to 0755 and 0644
	echo '<p>chmod htmlroot directory 0755 : files 0644</p>';
	recursive_chmod($targetdir, '0755', '0644');
	echo '<p>Done</p>';

	#joomla apache permission to 0777 and 0666
	echo '<h3>chmod '.$cmstype.' directory</h3>';
	foreach ($cmsdir[$cmstype] as $dir) {
		echo '<p>chmod '.$cmstype.' - <b>'.$dir.'</b> directory 0777 : files 0666</p>';
		recursive_chmod($targetdir.'/'.$dir, '0777', '0666');
		echo '<p class="no-margin">Done</p>';
	}

	#joomla config permission to 0755 and 0644
	echo '<h3>chmod '.$cmstype.' configuration</h3>';
	foreach ($cmscfg[$cmstype] as $dir) {
		echo '<p>chmod '.$cmstype.' - <b>'.$dir.'</b> directory 0755 : files 0644</p>';
		recursive_chmod($targetdir.'/'.$dir, '0755', '0644');
		echo '<p class="no-margin">Done</p>';
	}
	?>
	</div>
	<?php
}
elseif ( $_GET['task'] == 'show'){
	showParams('ftphost',$ftphost);
	showParams('ftpport',$ftpport);
	showParams('ftpuser',$ftpuser);
	showParams('ftppass',$ftppass);	
}
else { ?>
	<div class="main form">
	<form method="POST" action="<?php echo $script.'?task=chmod'; ?>">
	<h2>CMS chmod script</h2>
	<table>
		<tr>
			<td><?php echo $textCMS; ?></td>
			<td><select id="cmstype" name="cmstype" class="selectbox" >
			      <option value="joomla25">Joomla 2.5</option>
				  <option value="joomla30">Joomla 3.x</option>
			</select></td>
		</tr>
		<tr>
			<td><?php echo $textHost; ?></td>
			<td><input id="ftphost" name="ftphost" type="text" class="inputbox" value="localhost" /></td>
		</tr>
		<tr>
			<td><?php echo $textPort; ?></td>
			<td><input id="ftpport" name="ftpport" type="text" class="inputbox" value="21" /></td>
		</tr>
		<tr>
			<td><?php echo $textUser; ?></td>
			<td><input id="ftpuser" name="ftpuser" type="text" class="inputbox" value="" /></td>
		</tr>
		<tr>
			<td><?php echo $textPass; ?></td>
			<td><input id="ftppass" name="ftppass" type="password" class="inputbox" value="" /></td>
		</tr>
		<tr>
			<td><?php echo $textPath; ?></td>
			<td><input id="ftppath" name="ftppath" type="text" class="inputbox" value="<?php echo dirname(__FILE__); ?>" /></td>
		</tr>
	</table>
	<input type="submit" value="<?php echo $authText; ?>" class="submit-button" />
	</form>
	</div>
	<?php }
?>
<p class="footer">Joomla! CMMOD php script  by <a href="http://colorpack.co.th" title="ColorPack Creations Co., Ltd. รับทำเว็บ อบรม joomla! Wordpress ด้วยทีมงานมืออาชีพ">ColorPack Creations Co., Ltd. รับทำเว็บ อบรม joomla! Wordpress ด้วยทีมงานมืออาชีพ</a></p>
</body>
</html>